
#include "md5.h"
//#include "mdfile.h"
#include "sha1.h"
#include "rmd160p.h"
#ifdef ENABLE_SHA2
#include "sha256.h"
#include "sha3532.h"
#endif
#ifdef ENABLE_TIGER
#include "tiger.h"
#endif
#ifdef ENABLE_HAVAL
#include "haval.h"
#endif
#ifdef ENABLE_DOUBLESHA
#include "shadbl.h"
#endif


struct HashContext {
    int Hash;
    int hashsize;
    union {
        struct MD5Context md5ctx;
        struct SHA1Context sha1ctx;
        struct RMDctx rmdctx;
#ifdef ENABLE_SHA2
        sha_state sha256ctx;
        sha_state384 sha384ctx;
        sha_state512 sha512ctx;
#endif
#ifdef ENABLE_TIGER
        struct tiger_ctx tctx;
#endif
#ifdef ENABLE_HAVAL
        haval_state havalst;
#endif
#ifdef ENABLE_DOUBLESHA
        SHADoubleContext sha1x;
#endif
    } ctx;
};

int HashSize(int Hash);
char * HashName(int Hash);

void HashInit(struct HashContext *context, int Hash);
void HashUpdate(struct HashContext *context, unsigned char const *buf, unsigned len);
void HashFinal(byte *buf, struct HashContext *context);


int Hashfile0_len(struct HashContext *context, FILE *f, word32 longcount, int Hash);
int Hashfile0(struct HashContext *ctx, FILE * inFile, int Hash);
// Computes the message digest for a specified file
int Hashfile(struct HashContext *context, char *filename, int Hash);
// Used to finish the message digest, including extra material.
void Hash_addbuffer (struct HashContext *context, byte *buf, int buflen, byte *digest);
